/*
	The MIT License (MIT)
	Copyright (c) 2016, Gameblabla
	
	Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), 
	to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, 
	and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
	
	The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
	
	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
	INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
	IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
	TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

/*
 * The source code could be improved but i never bothered to. ;)
*/

#include "n2DLib.h"
#include "main.h"
#include "graphics.h"

#include <stdio.h>
#include <stdlib.h>

short right_spot[5], left_spot[5], up_spot[5], down_spot[5];

short CaseX;
short CaseY;
short Case_pos;
short Case_COLOR = 1;

short reload = 0;
short gamemo = 0;
short frame_gamemo = 0;
unsigned char good = 1;

unsigned char lives = 3;
unsigned long score = 0;
unsigned long highscore = 0;

short gamemode = 0;
unsigned char score_showed[7] , conv_time[4], highscore_show[7];
short rtime , lowtime = 10;
short go_time = 0;

int main(int argc, char* argv[])
{
	unsigned char done = 0;
	enable_relative_paths(argv);
	InitializeGame();

	while (!done)
	{
		if (isKeyPressed(KEY_NSPIRE_ESC)) done = 1;
		GameLoop();
		updateScreen();
	}

	deinitBuffering();
	return 0;
}

void InitializeGame()
{
	unsigned char i;
	
    initBuffering();
    clearBufferB();
    updateScreen();

	CaseX = 141;
	CaseY = 117;
	
	for (i=0;i<7;i++)
	{
		score_showed[i] = 0;
		highscore_show[i] = 0;
	}
	
	for (i=0;i<4;i++)
	{
		conv_time[i] = 0;
	}

	Load_score();
	reset_case();
}

void GameLoop()
{
	switch(gamemode)
	{
		case 0:
			drawSprite(img_title, 0, 0, 0, 0);
			Titlescreen();
			Show_highscore();
			Show_startbutton();
		break;

		case 1:
			drawSprite(img_background, 0, 0, 0, 0);
			Show_Square();
			if (gamemo == 0) Move_Square();
			Show_Game();
		break;
	}
}

void Titlescreen()
{
	if (isKeyPressed(KEY_NSPIRE_MENU) || isKeyPressed(KEY_NSPIRE_CTRL))
	{
		go_ingame();
	}
}

void Show_highscore()
{
	unsigned char i;
	Rect score_spr[7];
	
	for(i=0;i<7;i++)
	{
		score_spr[i].w = 16;
		score_spr[i].h = 16;
		score_spr[i].x = score_spr[i].w * (highscore_show[i]);
		score_spr[i].y = 0;
		drawSpritePart(img_score, 49+(12*i), 200, &score_spr[i], 0, 0);
	}
}

void Show_startbutton()
{
	static unsigned char time_press = 0;
	
	time_press++;
	
	if (time_press < 30)
	{
		drawSprite(img_startbutton, 90, 160, 0, 0);
	}
	else if (time_press > 59) 
	{
		time_press = 0;
	}
}

void Show_Square()
{
	static short frame = 0;
	Rect sqr;
	sqr.w = 40;
	sqr.h = 38;
	sqr.x = sqr.w * (frame);
	sqr.y = 0;

	drawSpritePart(img_all, CaseX, CaseY, &sqr, 0, 0);

	switch(gamemo)
	{
		case 2:
			go_time++;
			// Show "Game Over" frame
			frame = 14;
			if (go_time > 180) go_back_titlescreen();
		break;
		
		case 1:
			frame = 13;
			if (frame_gamemo > 35)
			{
				gamemo = 0;
				frame_gamemo = 0;
			}
			else frame_gamemo++;
		break;
		
		case 0:
			// Show the square you're holding
			frame = Case_pos;
		break;
	}


}

void Show_Game()
{
	unsigned char i;
	Rect score_spr[7], live_spr, time_spr[3];
	Rect spot_spr_left[4], spot_spr_right[4], spot_spr_up[4], spot_spr_down[4];
	
	rtime = reload;

	conv_time[0] = (rtime / 100) % 10;
	conv_time[1] = (rtime / 10) % 10;
	conv_time[2] = rtime % 10;
	
	lowtime = (rtime < 33) ? 10 : 0;
	
	//	Score_0 ,..., Score_6
	for (i=0;i<7;i++)
	{
		score_spr[i].w = 16;
		score_spr[i].h = 16;
		score_spr[i].x = score_spr[i].w * (score_showed[i]);
		score_spr[i].y = 0;

		drawSpritePart(img_score, 49+(i*12), 6, &score_spr[i], 0, 0);
	}
	
	//	Lives_spr
	live_spr.w = 16;
	live_spr.h = 16;
	live_spr.x = live_spr.w * (lives);
	live_spr.y = 0;
	drawSpritePart(img_score, 272, 6, &live_spr, 0, 0);
	
	// Time sprites
	for(i=0;i<3;i++)
	{
		time_spr[i].w = 16;
		time_spr[i].h = 16;
		time_spr[i].x = time_spr[i].w * (conv_time[i]+lowtime);
		time_spr[i].y = 0;
		drawSpritePart(img_score, 180+(i*16), 6, &time_spr[i], 0, 0);
	}

	// Spr_ready
	if (reload > 100)
	{
		drawSprite(img_ready, 111, 120, 0, 0);
	}

	/* 
	 * The following put the squares on screen
	 * If the square is empty then it is not shown
	*/

	for (i=0;i<4;i++)
	{
		spot_spr_left[i].w = 40;
		spot_spr_left[i].h = 38;
		spot_spr_left[i].x = spot_spr_left[i].w * (left_spot[i]);
		spot_spr_left[i].y = 0;
		spot_spr_right[i].w = 40;
		spot_spr_right[i].h = 38;
		spot_spr_right[i].x = spot_spr_right[i].w * (right_spot[i]);
		spot_spr_right[i].y = 0;
		spot_spr_up[i].w = 40;
		spot_spr_up[i].h = 38;
		spot_spr_up[i].x = spot_spr_up[i].w * (up_spot[i]);
		spot_spr_up[i].y = 0;
		spot_spr_down[i].w = 40;
		spot_spr_down[i].h = 38;
		spot_spr_down[i].x = spot_spr_down[i].w * (down_spot[i]);
		spot_spr_down[i].y = 0;
		
		if (left_spot[i] != 0) drawSpritePart(img_all, 77, 117, &spot_spr_left[i], 0, 0);
		if (right_spot[i] != 0) drawSpritePart(img_all, 205, 117, &spot_spr_right[i], 0, 0);
		if (up_spot[i] != 0) drawSpritePart(img_all, 141, 53, &spot_spr_up[i], 0, 0);
		if (down_spot[i] != 0) drawSpritePart(img_all, 141, 181, &spot_spr_down[i], 0, 0);
	}

}

unsigned short check_square_score(unsigned char sqr1, unsigned char sqr2, unsigned char sqr3, unsigned char sqr4)
{
	// Check if all squares are green
	if (sqr1 == 9 && sqr2 == 10 && sqr3 == 11 && sqr4 == 12)
		return 300;
	else if (sqr1 == 5 && sqr2 == 6 && sqr3 == 7 && sqr4 == 8)
		return 300;
	else if (sqr1 == 1 && sqr2 == 2 && sqr3 == 3 && sqr4 == 4)
		return 300;
	else
		return 30;
}

void Move_Square()
{
	unsigned char i;
	unsigned short sqr_score_filled;
	
	reload--;

	if (reload < 1)	// Player lose a live after 1.3 seconds
	{
		lose_a_life();
		reset_case();
	}
	else if (reload < 90) // Player can play after some ms
	{
		if (isKeyPressed(KEY_NSPIRE_UP))
		{
			for(i=0;i<4;i++)
			{
				if ((Case_pos == 1+i || Case_pos == 5+i || Case_pos == 9+i || Case_pos == 13+i))
				{
					if (up_spot[i] == 0)
						up_spot[i] = Case_pos;
					else
						lose_a_life();
				}	
			}
			
			if (up_spot[0] > 0 && up_spot[1] > 0 && up_spot[2] > 0 && up_spot[3] > 0)
			{
				sqr_score_filled = check_square_score(up_spot[0], up_spot[1], up_spot[2], up_spot[3]);
				for(i=0;i<4;i++) 
				{
					up_spot[i] = 0;
				}
				score = score + sqr_score_filled;
				calcul_score();
			}

			reset_case();
		}

		else if (isKeyPressed(KEY_NSPIRE_DOWN))
		{

			for(i=0;i<4;i++)
			{
				if ((Case_pos == 1+i || Case_pos == 5+i || Case_pos == 9+i || Case_pos == 13+i))
				{
					if (down_spot[i] == 0)
						down_spot[i] = Case_pos;
					else
						lose_a_life();
				}	
			}
			
			if (down_spot[0] > 0 && down_spot[1] > 0 && down_spot[2] > 0 && down_spot[3] > 0)
			{
				sqr_score_filled = check_square_score(down_spot[0], down_spot[1], down_spot[2], down_spot[3]);
				for(i=0;i<4;i++) 
				{
					down_spot[i] = 0;
				}
				score = score + sqr_score_filled;
				calcul_score();
			}

			reset_case();
		}

		else if (isKeyPressed(KEY_NSPIRE_LEFT))
		{
			
			for(i=0;i<4;i++)
			{
				if ((Case_pos == 1+i || Case_pos == 5+i || Case_pos == 9+i || Case_pos == 13+i))
				{
					if (left_spot[i] == 0)
						left_spot[i] = Case_pos;
					else
						lose_a_life();
				}	
			}

			if (left_spot[0] > 0 && left_spot[1] > 0 && left_spot[2] > 0 && left_spot[3] > 0)
			{
				sqr_score_filled = check_square_score(left_spot[0], left_spot[1], left_spot[2], left_spot[3]);
				for(i=0;i<4;i++) 
				{
					left_spot[i] = 0;
				}
				score = score + sqr_score_filled;
				calcul_score();
			}

			reset_case();
		}
		else if (isKeyPressed(KEY_NSPIRE_RIGHT))
		{
				for(i=0;i<4;i++)
				{
					if ((Case_pos == 1+i || Case_pos == 5+i || Case_pos == 9+i || Case_pos == 13+i))
					{
						if (right_spot[i] == 0)
							right_spot[i] = Case_pos;
						else
							lose_a_life();
					}	
				}
			
				if (right_spot[0] > 0 && right_spot[1] > 0 && right_spot[2] > 0 && right_spot[3] > 0)
				{
					sqr_score_filled = check_square_score(right_spot[0], right_spot[1], right_spot[2], right_spot[3]);
					for(i=0;i<4;i++) 
					{
						right_spot[i] = 0;
					}
					score = score + sqr_score_filled;
					calcul_score();
				}

			reset_case();
		}
	}

}

void RESET_EVERYTHING()
{
	unsigned char i;
	
	reload = 0;
	gamemo = 0;
	frame_gamemo = 0;
	go_time = 0;
	score = 0;
	rtime = 0;
	
	lowtime = 10;
	lives = 3;
	
	gamemode = 1;
	good = 1;
	
	for (i=0;i<4;i++)
	{
		right_spot[i] = 0;
		left_spot[i] = 0;
		up_spot[i] = 0;
		down_spot[i] = 0;
	}
	
	for (i=0;i<7;i++)
	{
		score_showed[i] = 0;
	}

}

// Generate a random number
short reset_case() 
{
			good = 1;

			// Avoid giving a square where it can't be placed anywhere
			// Loop until the game finds a good combinaison
			// In theory, the game could loop indefinitely but it never happened to me
			
			// If good = 0 then it means it found a good combinaison
			while (good)
			{
				Case_pos = rand_a_b(1,12);

				if (up_spot[0] > 0 && right_spot[0] > 0 && left_spot[0] > 0 && down_spot[0] && (Case_pos == 1 || Case_pos == 5 || Case_pos == 9 || Case_pos == 13)) 
				{
					good = 1;
				}
				else if (up_spot[1] > 0 && right_spot[1] > 0 && left_spot[1] > 0 && down_spot[1] && (Case_pos == 2 || Case_pos == 6 || Case_pos == 10 || Case_pos == 14)) 
				{
					good = 1;
				}
				else if (up_spot[2] > 0 && right_spot[2] > 0 && left_spot[2] > 0 && down_spot[2] && (Case_pos == 3 || Case_pos == 7 || Case_pos == 11 || Case_pos == 15)) 
				{
					good = 1;
				}
				else if (up_spot[3] > 0 && right_spot[3] > 0 && left_spot[3] > 0 && down_spot[3] && (Case_pos == 4 || Case_pos == 8 || Case_pos == 12 || Case_pos == 16)) 
				{
					good = 1;
				}
				else
				{
					good = 0;
				}
			}
			
			switch(Case_pos)
			{
				case 1:
				case 2:
				case 3:
				case 4:
					Case_COLOR = 1;
				break;
				
				case 5:
				case 6:
				case 7:
				case 8:
					Case_COLOR = 2;
				break;
				
				case 9:
				case 10:
				case 11:
				case 12:
					Case_COLOR = 3;
				break;
				
				case 13:
				case 14:
				case 15:
				case 16:
					Case_COLOR = 4;
				break;
			}

			reload = 100;
			frame_gamemo = 0;

	return 1;
}

void lose_a_life()
{
	lives = lives - 1;
	gamemo = (lives < 1) ? 2 : 1;
}

void calcul_score()
{
	score_showed[0] = (score / 1000000) % 10;
	score_showed[1] = (score / 100000) % 10;
	score_showed[2] = (score / 10000) % 10;
	score_showed[3] = (score / 1000) % 10;
	score_showed[4] = (score / 100) % 10;
	score_showed[5] = (score / 10) % 10;
	score_showed[6] = score % 10;
}

static unsigned long int next = 1;

int rand(void)
{
    next = next * 1103515245 + 12345;
    return (unsigned int)(next/65536) % 32768;
}

short rand_a_b(short a, short b)
{
    return rand()%(b-a) +a;
}

void go_back_titlescreen()
{
	Update_highscore();
	Load_score();

	gamemode = 0;
}

void go_ingame()
{
	RESET_EVERYTHING();
	reload = 200;
	gamemode = 1;
}


void Load_score()
{
		FILE* file;
		file = NULL;
		char* directory;
		unsigned char i;
		
		directory = "./killminds.save.tns";
		
		file = fopen(directory, "r+");
		
		if (file != NULL)
		{
			for(i=0;i<7;i++)
			{
				highscore_show[i] = fgetc(file);
			}
		}
		else
		{
			// If the file does not exist then create it
			file = fopen(directory, "w");
			for(i=0;i<7;i++)
			{
				fputc( highscore_show[i], file );
			}
		}
		
		fclose(file);
		
}

void Save_score()
{
		FILE* file;
		char* directory;
		unsigned char i;
		
		directory = "./killminds.save.tns";
		
		highscore_show[0] = (highscore / 1000000) % 10;
		highscore_show[1] = (highscore / 100000) % 10;
		highscore_show[2] = (highscore / 10000) % 10;
		highscore_show[3] = (highscore / 1000) % 10;
		highscore_show[4] = (highscore / 100) % 10;
		highscore_show[5] = (highscore / 10) % 10;
		highscore_show[6] = highscore % 10;
		
		file = fopen(directory, "w+");
		
		for(i=0;i<7;i++)
		{
			fputc( highscore_show[i], file );
		}
		
		fclose(file);
}

void Update_highscore()
{
	if (score > highscore)
	{
		highscore = score;
			
		highscore_show[0] = (highscore / 1000000) % 10;
		highscore_show[1] = (highscore / 100000) % 10;
		highscore_show[2] = (highscore / 10000) % 10;
		highscore_show[3] = (highscore / 1000) % 10;
		highscore_show[4] = (highscore / 100) % 10;
		highscore_show[5] = (highscore / 10) % 10;
		highscore_show[6] = highscore % 10;
		Save_score();
	}
}
